#!/bin/sh

#
# Copyright (c) 2008 Peter Holm <pho@FreeBSD.org>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FreeBSD: projects/stress2/misc/unionfs2.sh 187224 2009-01-14 16:03:10Z pho $
#

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

. ../default.cfg

saved=`sysctl vfs.lookup_shared | awk '{print $NF}'`
ORUNDIR=$RUNDIR
for i in 1 0; do
	sysctl vfs.lookup_shared=$i
	[ -d /var/tmp/unionfs ] || mkdir -p /var/tmp/unionfs
	mount -t unionfs /var/tmp/unionfs $RUNDIR

	export RUNDIR=/var/tmp/unionfs/stressX
	export runRUNTIME=10m            # Run tests for 10 minutes
	(cd ..; ./run.sh disk.cfg) 
	while mount | grep -q /unionfs; do
		umount $ORUNDIR > /dev/null 2>&1
	done
	rm -rf /var/tmp/unionfs
done
sysctl vfs.lookup_shared=$saved
